'use strict';
const emojiRegex = /\uD83D\uDC69\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D(?:\uD83D\uDC69\u200D)?\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D(?:\uD83D\uDC69\u200D)?\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92])|\uD83D\uDC68(?:\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC66\u200D\uD83D\uDC66|\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68)|(?:\uD83C[\uDFFB-\uDFFF])\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]))|(?:\uD83D\uDC69\u200D[\u2695\u2696\u2708]|\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2695\u2696\u2708]|\uD83D\uDC68(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708]))\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC6F\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3C-\uDD3E\uDDD6-\uDDDF])\u200D[\u2640\u2642]\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]\uFE0F|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uFE0F\u200D[\u2640\u2642])\uFE0F|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDD1-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83D\uDC68(?:\u200D(?:(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC67|(?:(?:\uD83D[\uDC68\uDC69])\u200D)?\uD83D\uDC66)|\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69(?:\u200D(?:(?:\uD83D\uDC69\u200D)?\uD83D\uDC67|(?:\uD83D\uDC69\u200D)?\uD83D\uDC66)|\uD83C[\uDFFB-\uDFFF])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|[#\*0-9]\uFE0F\u20E3|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC69\uDC6E\uDC70-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD18-\uDD1C\uDD1E\uDD1F\uDD26\uDD30-\uDD39\uDD3D\uDD3E\uDDD1-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])?|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDEEB\uDEEC\uDEF4-\uDEF8]|\uD83E[\uDD10-\uDD3A\uDD3C-\uDD3E\uDD40-\uDD45\uDD47-\uDD4C\uDD50-\uDD6B\uDD80-\uDD97\uDDC0\uDDD0-\uDDE6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u2660\u2663\u2665\u2666\u2668\u267B\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEF8]|\uD83E[\uDD10-\uDD3A\uDD3C-\uDD3E\uDD40-\uDD45\uDD47-\uDD4C\uDD50-\uDD6B\uDD80-\uDD97\uDDC0\uDDD0-\uDDE6])\uFE0F/g;
var extensionVersion = chrome.runtime.getManifest().version;
var i18n = {
    'default': {
        'context': {
            'image': 'Save Image to Eagle(&Z)',
            'video': 'Save Video to Eagle(&Z)',
        }
    },
    'de': {
        'context': {
            'image': 'Bild in Eagle speichern(&Z)',
            'video': 'Video in Eagle speichern(&Z)',
        }
    },
    'es': {
        'context': {
            'image': 'Guardar imágen en Eagle(&Z)',
            'video': 'Guardar video en Eagle(&Z)',
        }
    },
    'ru': {
        'context': {
            'image': 'Сохранить изображение вEagle(&Z)',
            'video': 'Сохранить видео вEagle(&Z)',
        }
    },
    'ja': {
        'context': {
            'image': '画像を Eagle に保存(&Z)',
            'video': '映像を Eagle に保存(&Z)',
        }
    },
    'zh-TW': {
        'context': {
            'image': '將圖片保存至 Eagle(&Z)',
            'video': '將影片保存至 Eagle(&Z)',
        }
    },
    'zh-CN': {
        'context': {
            'image': '将图片保存至 Eagle(&Z)',
            'video': '将视频保存至 Eagle(&Z)',
        }
    },
};

var i18n_words = i18n['default'];
var languageMap = {
    "zh": "zh-CN",
    'es': 'es',
    'de': 'de',
    'ru': 'ru',
    'ja': 'ja',
    'ko': 'ko',
    'en': 'en'
};
var language = window.navigator.language.toLowerCase();
var languageKey = language.split("-")[0];
var i18nKey = languageMap[languageKey];
if (language === 'zh-tw') {
    i18n_words = i18n['zh-TW'];
}
else if (i18n[i18nKey]) {
    i18n_words = i18n[i18nKey];
}

chrome.contextMenus.create({
    contexts: ["all"],
    id: 'background_img',
    title: i18n_words.context['image']
});

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if (request.message == 'getAppInfo') {
        fetch("http://localhost:41595/api/application/info")
            .then(function(response) { return response.json(); })
            .then(function(result) {
                if (result && result.data) {
                    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                        chrome.tabs.sendMessage(tabs[0].id, { action: "get-app-info", data: result.data });
                    });
                }
            });
    }
    else if (request.message == 'getRecentFolders') {
        fetch("http://localhost:41595/api/folder/listRecent")
            .then(function(response) { return response.json(); })
            .then(function(result) {
                if (result && result.data) {
                    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                        chrome.tabs.sendMessage(tabs[0].id, { action: "get-recent-folder", data: result.data });
                    });
                }
            });
    }
    else if (request.message == 'updateContextMenu') {
        if (request.type === "video") {
            chrome.contextMenus.update('background_img', {
                visible: true,
                contexts: ["all"],
                title: i18n_words.context['video']
            });
        } 
        else if (request.type === "image") {
            chrome.contextMenus.update('background_img', {
                visible: true,
                contexts: ["all"],
                title: i18n_words.context['image']
            });
        }
        else {
            chrome.contextMenus.update('background_img', {
                visible: false,
                contexts: ["all"],
                title: i18n_words.context['image']
            });
        }
    }
    if (request.action === "screencapture") {
        var pixelRatio = request.pixelRatio || 1;
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
            var tab = tabs[0];
            currentTab = tab; // used in later calls to get tab info
            var filename = getFilename(tab.url);
            webCapture(tab, filename, finishCaptures, errorHandler, pixelRatio);
        });
    }
    // 截取当前画面
    else if (request.action === "capture-visible") {

        var pixelRatio = request.pixelRatio || 1;
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            var tab = tabs[0];
            currentTab = tab;
            var id = (tabs[0] && tabs[0].id) || currentTab.id;
            var format = localStorage.getItem("captureFormat") || 'png';

            chrome.tabs.executeScript(currentTab.id, {
                code : `document.getElementsByTagName("html")[0].classList.add("eagle-cropper-opened")`
            });

            setTimeout(function () {
                chrome.tabs.captureVisibleTab(null, {format: format, quality: 100}, function(dataURI) {
                    chrome.tabs.executeScript(currentTab.id, {
                        code : `document.getElementsByTagName("html")[0].classList.remove("eagle-cropper-opened")`
                    });
                    if (dataURI) {
                        if (pixelRatio > 1 && !useRetina) {
                            var image = new Image();
                            image.onload = function() {
                                var canvas = document.createElement('canvas');
                                canvas.width = image.width;
                                canvas.height = image.height;
                                var ctx = canvas.getContext('2d');
                                ctx.drawImage(
                                    image,
                                    0,
                                    0
                                );
                                canvas = resizeCanvas(canvas, pixelRatio);
                                var base64String;
                                if (format === "png") {
                                    base64String = canvas.toDataURL();
                                }
                                else {
                                    base64String = canvas.toDataURL("image/jpeg", 1);
                                }
                                finishCaptures(base64String);
                            };
                            image.src = dataURI;
                        }
                        else {
                            finishCaptures(dataURI);
                        }
                    }
                });
            }, 200);
        });
    }
    else if (request.action === "batch-save") {
        chrome.tabs.executeScript(null, { file: "getPagesSource.js" });
    }
    else if (request.action === "change-retina") {
        useRetina = request.useRetina || false;
    }
    else if (request.action === "save-url") {
        chrome.tabs.executeScript(null, { file: "saveURL.js" });
    }
    return true;
});

function saveUrlToEagle (metas, base64) {
    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        var tab = tabs[0];
        window.jQuery.ajax({
            method:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                version: extensionVersion,
                type: "save-url",
                title: tab.title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, ''),
                url: tab.url,
                width: parseInt(metas.videoWidth),
                height: parseInt(metas.videoHeight),
                medium: metas.videoMedium,
                videoID: metas.videoID,
                videoEmbed: metas.videoEmbed,
                videoDuration: metas.videoDuration,
                base64: base64,
                favicon: metas.favicon
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
        })
    });
}

var currentTab, // result of chrome.tabs.query of current active tab
    resultWindowId; // window id for putting resulting images
var isBackground = true;
var captureFormat = 'png';
var useRetina = false;

captureFormat = localStorage.getItem("captureFormat") || 'png';
chrome.storage.sync.get(['captureFormat'], function(result) {
    if (result.captureFormat === undefined) {
        captureFormat = 'png';
    }
    else {
        captureFormat = result.captureFormat;
    }
});

useRetina = localStorage.getItem("useRetina") === 'true';

function getFilename(contentURL) {
    var name = contentURL.split('?')[0].split('#')[0];
    if (name) {
        name = name
            .replace(/^https?:\/\//, '')
            .replace(/[^A-z0-9]+/g, '-')
            .replace(/-+/g, '-')
            .replace(/^[_\-]+/, '')
            .replace(/[_\-]+$/, '');
        name = '-' + name;
    } else {
        name = '';
    }
    return 'screencapture' + name + '-' + Date.now() + '.png';
}

function finishCaptures(base64String, index) {

    var indexStr = "";
    if (index) {
        indexStr = " #" + index
    }

    chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
        window.jQuery.ajax({
            type:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                version: extensionVersion,
                type: "screen capture",
                title: currentTab.title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, '') + indexStr,
                url: currentTab.url,
                base64: base64String,
            },
            success: function(result){
                
                // setTimeout(function () {
                //     window.close();
                // }, 500);
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
            else {
                chrome.tabs.sendMessage(currentTab.id, { action: "close-crop-area" }, function(response) {});
            }
        });
    });
}

function errorHandler(reason) {}

chrome.commands.onCommand.addListener(function(command) {
    switch (command) {
        case "quick-save":
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
                chrome.tabs.sendMessage(tabs[0].id, { action: "quick-save" }, function(response) {});
            });
            break;
        case "save-images":
            chrome.tabs.executeScript(null, { file: "getPagesSource.js" });
            break;
        case "capture-entire-beta":
            openWebCapture();
            break;
        case "capture-selected":
            openSceenshot();
            break;
    }
});

function openWebCapture () {
    chrome.tabs.query({active: true}, function(tabs){
        window.jQuery.ajax({
            method:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                version: extensionVersion,
                type: "capture-website",
                title: currentTab.title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, ''),
                url: currentTab.url,
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
        })
    });
}

function openSceenshot () {
    chrome.tabs.query({active: true}, function(tabs){
        window.jQuery.ajax({
            method:"POST",
            url: "http://localhost:41593",
            // dataType: "json",
            data: {
                version: extensionVersion,
                type: "screenshot",
                title: currentTab.title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, ''),
                url: currentTab.url,
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
        })
    });
}

chrome.contextMenus.onClicked.addListener(function onContextMenu(info, tab) {
    chrome.tabs.sendMessage(tab.id, '', function onMessageResponse(msg) {
        if (!msg || !msg.src) return;
        ensureEagleIsOpen(function () {
            msg.src = convertSrc(msg.src);
            // console.time("取得图片 base64 - ");
            toDataURL(msg.src, function(base64) {
                // console.timeEnd("取得图片 base64 - ");
                var result = base64 || msg.src;
                window.jQuery.ajax({
                    type: "POST",
                    url: "http://localhost:41593",
                    // dataType: "json",
                    timeout: 20000,
                    data: {
                        version: extensionVersion,
                        type: "image",
                        title: msg.title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, ''),
                        url: msg.link || tab.url,
                        src: result,
                        metaAlt: msg.metaAlt,
                        metaTitle: msg.metaTitle,
                        metaDescription: msg.metaDescription,
                        metaKeywords: msg.metaKeywords,
                        metaTags: msg.metaTags,
                        // forceOpenCollectModal: msg.forceOpenCollectModals
                    }
                }).always(function(result) {
                    if (result.status == 0) {
                        openEagle();
                    }
                })
            });
        });
    });
});

chrome.runtime.onMessage.addListener(function(msg, sender, sendResponse) {
    if (msg.action == "getSource") {
        chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
            var images = JSON.parse(msg.source);
            images.forEach(function (image) {
                if (!image.title) {
                    image.title = tabs[0].title;
                }

                // 有些网址可能是 "url 1.5x" 这样的格式，需避免
                if (image.src && image.src.indexOf(" ") > -1) {
                    image.src = image.src.trim().split(" ")[0];
                }
                
                if (image.src !== convertSrc(image.src)) {
                    image.urlConverted = true;
                    image.src = convertSrc(image.src) || image.src;    
                }

                image.title = image.title.replace(emojiRegex, '').replace(/[#$%^&*()<>:'"\/\\|?*]+/g, '');
            });
            window.jQuery.ajax({
                method:"POST",
                url: "http://localhost:41593",
                // dataType: "json",
                data: {
                    version: extensionVersion,
                    type: "import-images",
                    title: tabs[0].title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, ''),
                    url: tabs[0].url,
                    images: JSON.stringify(images),
                }
            }).always(function (result) {
                if (result.status == 0) {
                    openEagle();
                }
            })
        });
    }
    else if (msg.action == "saveURL") {
        var metas = msg.result;
        if (metas.videoThumb) {
            toDataURL(metas.videoThumb, function(base64) {
                saveUrlToEagle(metas, base64);
            }, 10000);
        }
        else {
            chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                var tab = tabs[0];
                chrome.tabs.executeScript(tab.id, {
                    code : `document.getElementsByTagName("html")[0].classList.add("eagle-cropper-opened")`
                });
                setTimeout(function () {
                    chrome.tabs.captureVisibleTab(null, {format: "jpeg", quality: 75}, function(dataURI) {
                        var image = new Image();
                        image.onload = function() {
                            var canvas = document.createElement('canvas');
                            if (image.width > 720) {
                                canvas.width = 720;
                                canvas.height = parseInt(720 * image.height / image.width);
                            }
                            else {
                                canvas.width = image.width;
                                canvas.height = image.height;
                            }
                            var ctx = canvas.getContext('2d');
                            ctx.drawImage(image, 0, 0, canvas.width, canvas.height);
                            var base64String = canvas.toDataURL();
                            saveUrlToEagle(metas, base64String);
                            chrome.tabs.executeScript(tab.id, {
                                code : `document.getElementsByTagName("html")[0].classList.remove("eagle-cropper-opened")`
                            });
                        };
                        image.src = dataURI;
                    });
                }, 200);
            });
        }
    }
    else if (msg.src) {
        chrome.tabs.query({ active: true, currentWindow: true }, function(tabs) {
            chrome.tabs.sendMessage(tabs[0].id, '', function onMessageResponse(src) {
                
                ensureEagleIsOpen(function () {
                    msg.src = convertSrc(msg.src);
                    if (!msg.src) return;
                    // console.time("取得图片 base64");
                    toDataURL(msg.src, function(base64) {
                        // console.timeEnd("取得图片 base64");
                        var result = base64 || msg.src;
                        var data = {
                            version: extensionVersion,
                            type: "image",
                            title: msg.title.replace(/[#$%^&*()<>:'"\/\\|?*]+/g, ''),
                            url: msg.link || tabs[0].url,
                            src: result,
                            folderID: msg.folderID,
                            extendTags: msg.extendTags || "",
                            metaAlt: msg.metaAlt,
                            metaTitle: msg.metaTitle,
                            metaDescription: msg.metaDescription,
                            metaKeywords: msg.metaKeywords,
                            metaTags: msg.metaTags
                        };
                        if (msg.forceOpenCollectModal) {
                            data.forceOpenCollectModal = true;
                        }
                        if (msg.forceHideCollectModal) {
                            data.forceHideCollectModal = true;
                        }
                        window.jQuery.ajax({
                            type: "POST",
                            url: "http://localhost:41593",
                            // dataType: "json",
                            timeout: 20000,
                            data: data
                        }).always(function(result) {
                            if (result.status == 0) {
                                openEagle();
                            }
                        })
                    });
                });
            });
        });
    }
    return true;
});

function toDataURL(url, callback, curtomTimeout) {
    var xhr = new XMLHttpRequest();
    var sent = false;
    var isVideo = url.toLowerCase().indexOf(".mp4") > -1 || url.toLowerCase().indexOf(".webm") > -1;
    var isGIF = url.toLowerCase().indexOf(".gif") > -1;
    var timeout = 700;
    if (isGIF) {
        timeout = 1200;
    }
    if (curtomTimeout) {
        timeout = curtomTimeout;
    }
    if (isVideo) {
        callback(undefined);
        return;
    }
    // console.log(url);
    xhr.onload = function() {
        clearTimeout(timeout);
        var reader = new FileReader();
        reader.onloadend = function() {
            if (!sent) {
                sent = true;
                if (reader.result.indexOf("data:image") > -1) {
                    callback(reader.result);
                }
                else {
                    callback(undefined);
                }
            }
        }
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.responseType = 'blob';
    xhr.send();

    timeout = setTimeout(function () {
        if (!sent) {
            sent = true;
            // 超过时间没下载，中断下载
            xhr.abort();
            callback(undefined);
        }
    }, timeout);
}

function openEagle () {
    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        chrome.tabs.sendMessage(tabs[0].id, { action: "open-not-opened-modal" }, function(response) {});
    });
};

function convertSrc(src) {
    if (src.indexOf("data:image") > -1) return src;
    if (SIEVE && SIEVE.rules) {
        for (let i = 0; i < SIEVE.rules.length; i++) {
            try {
                const rule = SIEVE.rules[i];
                var srcPattern = rule.srcPattern;
                var replaceRule = rule.replaceRule;
                var reg = RegExp(srcPattern);
                if (reg.test(src)) {
                    var newSrc = rule.replace(src);
                    console.log(`${rule.site} > ${newSrc}`);
                    return newSrc;
                }
            }
            catch (err) {
                return src;
            }
        }
    }
    return src;
}

// 安装扩展后，自动将扩展需要的代码塞入所有的页面中，这样用户就不需要手动刷新了。
// chrome.runtime.onInstalled.addListener(function () {
//     console.log("onInstalled");
//     chrome.tabs.query({}, function(tabs) {
//         for (var i = 0; i < tabs.length; ++i) {
//             if (tabs[i].url && tabs[i].url.indexOf("http") !== -1) {
//                 var url = tabs[i].url;
//                 if (!/^(?:http(s)?:\/\/)?[\w.-]+(?:\.[\w\.-]+)+[\w\-\._~:/?#[\]@!\$&'\(\)\*\+,;=.]+$/gm.test(url)) continue;
//                 if (url.indexOf("chrome.google.com/webstore") > -1) continue;
//                 chrome.tabs.insertCSS(tabs[i].id, { file: 'eagle-extension.css' });
//                 executeScripts(tabs[i].id, [ 
//                     { file: "jquery.min.js" },
//                     { file: "jquery-ui.min.js" },
//                     { file: "mousetrap.min.js" },
//                     { file: "extract-text.js" },
//                     { file: "utils.js" },
//                     { file: "content.js" }
//                 ]);
//             }
//         }
//     });
// });

function executeScripts(tabId, injectDetailsArray) {
    function createCallback(tabId, injectDetails, innerCallback) {
        return function () {
            chrome.tabs.executeScript(tabId, injectDetails, innerCallback);
        };
    }

    var callback = null;

    for (var i = injectDetailsArray.length - 1; i >= 0; --i)
        callback = createCallback(tabId, injectDetailsArray[i], callback);

    if (callback !== null)
        callback();   // execute outermost function
}

function ensureEagleIsOpen (callback) {
    window.jQuery.ajax({
        version: extensionVersion,
        type:"GET",
        url: "http://localhost:41593",
        success: function(result){}
    }).always(function (result) {
        if (result.status == 0) {
            openEagle();
        }
        else {
            callback();
        }
    });
}